package com.allmycode.p03_03_01

import android.content.DialogInterface
import android.content.Intent
import android.net.Uri
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import androidx.fragment.app.Fragment
import kotlinx.android.synthetic.main.activity_main.*
import kotlinx.android.synthetic.main.fragment_special_content.*
import android.app.AlertDialog.Builder
import android.telecom.Call
import androidx.appcompat.app.AlertDialog


class MainActivity : AppCompatActivity(), SpecialContent.OnFragmentInteractionListener {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        this.Caller.setText(intent.getStringExtra("Caller"))

        val transaction = supportFragmentManager.beginTransaction()
        transaction.replace(R.id.flContent, SpecialContent.newInstance())
        transaction.commit()
    }

    fun onFirstLocClick(view: View){
        val goto = Intent("android.intent.action.FIRST")
        goto.putExtra("Caller", "Main Activity")
        startActivity(goto)
    }

    fun onSecondLocClick(view: View){
        val goto = Intent("android.intent.action.SECOND")
        goto.putExtra("Caller", "Main Activity")
        startActivity(goto)
    }

    override fun onFragmentInteraction(uri: Uri) {

    }

    fun onHideClick(view: View){
        if (supportFragmentManager.fragments.size > 0 &&
            supportFragmentManager.fragments[0] != null) {
            val transaction = supportFragmentManager.beginTransaction()
            transaction.addToBackStack(null)
            transaction.hide(supportFragmentManager.fragments[0])
            transaction.commit()
        }
    }

    fun onShowClick(view: View){
        if (supportFragmentManager.fragments.size > 0 &&
            supportFragmentManager.fragments[0] != null) {
            val transaction = supportFragmentManager.beginTransaction()
            transaction.show(supportFragmentManager.fragments[0])
            transaction.commit()
        }
    }

    fun onAlertClick(view: View) {
        AlertDialog.Builder(this)
            .setCancelable(false)
            .setTitle("Alert Dialog")
            .setMessage("This is an alert dialog!")
            .setIcon(android.R.drawable.ic_dialog_alert)
            .setNegativeButton("Close",
                DialogInterface.OnClickListener
            { dialog, which -> dialog.cancel()
            }).setPositiveButton("Ok",
                DialogInterface.OnClickListener
            { dialog, which -> dialog.dismiss()}).create().show()
    }

    fun onDlgFragmentClick(view: View) {
        val transaction =
            supportFragmentManager.beginTransaction()
        val MyDialog = FragmentDialog.newInstance()
        MyDialog.show(transaction, "FragmentDialog")
    }

    fun onBtnOKClick(view: View) {
        val MyDialog: FragmentDialog =
            supportFragmentManager.findFragmentByTag(
                "FragmentDialog") as FragmentDialog
        MyDialog.onBtnOKClick(view)
    }

    fun onBtnCancelClick(view: View) {
        val MyDialog: FragmentDialog =
            supportFragmentManager.findFragmentByTag(
                "FragmentDialog") as FragmentDialog
        MyDialog.onBtnCancelClick(view)
    }
}
