package com.allmycode.p03_03_02

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle

import android.net.Uri
import android.view.View
import androidx.navigation.*
import androidx.navigation.fragment.NavHostFragment
import kotlinx.android.synthetic.main.activity_main.*


class MainActivity : AppCompatActivity(),
    MainEntry.OnFragmentInteractionListener,
    DoStuff.OnFragmentInteractionListener,
    SeeResults.OnFragmentInteractionListener,
    SayGoodbye.OnFragmentInteractionListener {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
    }

    override fun onFragmentInteraction(uri: Uri) {

    }

    fun onGoDoStuffClick(view: View){
        Caller.setText("Caller: MainEntry")
        val navController = Navigation.findNavController(
            this, R.id.nav_host)
        navController.navigate(
            R.id.action_mainEntry_to_doStuff)
    }

    fun onGoResultsClick(view: View){
        val navController = Navigation.findNavController(
            this, R.id.nav_host)
        val Fragments :NavHostFragment =
            supportFragmentManager.findFragmentById(
                R.id.nav_host) as NavHostFragment
        if(Fragments.childFragmentManager.fragments[0]
                    is MainEntry) {
            Caller.setText("Caller: MainEntry")
            navController.navigate(R.id.action_mainEntry_to_seeResults)
        } else {
            Caller.setText("Caller: DoStuff")
            navController.navigate(
                R.id.action_doStuff_to_seeResults)
        }
     }

    fun onGoSayGoodbyeClick(view: View){
        val navController = Navigation.findNavController(
            this, R.id.nav_host)
        val Fragments :NavHostFragment =
            supportFragmentManager.findFragmentById(
                R.id.nav_host) as NavHostFragment
        if(Fragments.childFragmentManager.fragments[0]
                    is SeeResults) {
            Caller.setText("Caller: SeeResults")
            navController.navigate(R.id.action_seeResults_to_sayGoodbye)
        } else {
            Caller.setText("Caller: DoStuff")
            navController.navigate(R.id.action_doStuff_to_sayGoodbye)
        }
    }

    fun onPreviousClick(view: View) {
        val navController = Navigation.findNavController(
            this, R.id.nav_host)
        val Fragments :NavHostFragment =
            supportFragmentManager.findFragmentById(
                R.id.nav_host) as NavHostFragment
        when (Fragments.childFragmentManager.fragments[0]) {
            is MainEntry -> Caller.setText("Caller: MainEntry")
            is DoStuff -> Caller.setText("Caller: DoStuff")
            is SeeResults -> Caller.setText("Caller: SeeResults")
            is SayGoodbye -> Caller.setText("Caller: SayGoodbye")
        }
        navController.navigateUp()
    }
}
