package com.allmycode.p03_03_03

import android.content.Context
import android.content.pm.PackageManager
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import android.widget.ImageView
import android.widget.Toast
import androidx.work.*
import kotlinx.android.synthetic.main.activity_main.*
import java.io.File
import java.io.FileOutputStream
import android.os.Environment
import androidx.core.app.ActivityCompat
import androidx.core.content.ContextCompat

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
    }

    internal fun applyCycle(){
        val requestCode = 1
        ActivityCompat.requestPermissions(this,
            arrayOf(android.Manifest.permission.WRITE_EXTERNAL_STORAGE,
                android.Manifest.permission.READ_EXTERNAL_STORAGE),
            requestCode)

        val oneTimeRequest = OneTimeWorkRequest.Builder(WriteFile::class.java)
            .addTag("Worker")
            .build()
        WorkManager.getInstance(this).enqueue(oneTimeRequest)
    }

    fun buttonOnClick(view: View) {
        viewModelStore.apply { applyCycle() }
        if (WorkManager.getInstance(this).getWorkInfosByTag("Worker").isDone())
            Toast.makeText(this, "Completed Successfully!", Toast.LENGTH_LONG)
        else
            Toast.makeText(this, "Failed!", Toast.LENGTH_LONG)
    }

}

class WriteFile(ctx: Context, params: WorkerParameters) :
    Worker (ctx, params) {
    override fun doWork(): Result {
        val permCheck = ContextCompat.checkSelfPermission(
            applicationContext,
            android.Manifest.permission.WRITE_EXTERNAL_STORAGE)
        if (permCheck == PackageManager.PERMISSION_DENIED)
            return Result.failure()

        val path = applicationContext.getDir("Data", Context.MODE_PRIVATE)
        val outFile = File(path, "Test.txt")
        if (!outFile.exists())
            outFile.createNewFile()
        outFile.writeText("This is a test!")
        outFile.outputStream().flush()
        outFile.outputStream().close()
        return Result.success()
    }
}