package com.allmycode.p03_04_02

import android.os.Bundle
import android.os.PersistableBundle
import com.google.android.material.snackbar.Snackbar
import androidx.appcompat.app.AppCompatActivity
import android.view.Menu
import android.view.MenuItem
import android.view.View
import androidx.preference.*
import kotlinx.android.synthetic.main.activity_main.*
import kotlinx.android.synthetic.main.content_main.*

private const val USER_NAME = "UserName"
private const val SHOW_USER = "ShowUser"

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        setSupportActionBar(toolbar)

        fab.setOnClickListener { view ->
            Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                .setAction("Action", null).show()
        }

        if (savedInstanceState != null) {
            UserName.setText(
                savedInstanceState.getCharSequence(USER_NAME))
            UserName.visibility = savedInstanceState.getInt(
                SHOW_USER)
        }
    }

    override fun onCreateOptionsMenu(menu: Menu): Boolean {
        // Inflate the menu; this adds items to the action bar if it is present.
        menuInflater.inflate(R.menu.menu_main, menu)
        return true
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        if (item.itemId == R.id.action_settings) {
            supportFragmentManager
                .beginTransaction()
                .replace(R.id.preferences, NamePreferences())
                .addToBackStack(null)
                .commit()

            supportActionBar?.setDisplayHomeAsUpEnabled(true)
        }

        return when (item.itemId) {
            R.id.action_settings -> true
            else -> super.onOptionsItemSelected(item)
        }
    }

    override fun onSaveInstanceState(
        outState: Bundle,
        outPersistentState: PersistableBundle) {

        super.onSaveInstanceState(outState,
            outPersistentState)
        outState.putCharSequence(USER_NAME, UserName.text)
        outState.putInt(SHOW_USER, UserName.visibility)
    }

    override fun onSupportNavigateUp(): Boolean {
        val sharedPreferences = PreferenceManager
            .getDefaultSharedPreferences(this)
        UserName.setText(sharedPreferences.getString(
            "NewName", ""))
        if (sharedPreferences.getBoolean("ShowName", true))
            UserName.visibility = View.VISIBLE
        else
            UserName.visibility = View.INVISIBLE

        if (supportFragmentManager.popBackStackImmediate()) {
            supportActionBar?.setDisplayHomeAsUpEnabled(false)
            return true
        }
        return super.onSupportNavigateUp()
    }
}

class NamePreferences: PreferenceFragmentCompat() {
    override fun onCreatePreferences(
        savedInstanceState: Bundle?, rootKey: String?) {

        setPreferencesFromResource(
            R.xml.preference_main, rootKey)

        val showName: CheckBoxPreference? =
            findPreference("ShowName")
        val nameValue: EditTextPreference? =
            findPreference("NewName")
        val PrefChanges: Preference
            .OnPreferenceChangeListener =
            object : Preference.OnPreferenceChangeListener {
                override fun onPreferenceChange(
                    preference: Preference?,
                        newValue: Any?): Boolean {

                    // Add Your Validation Code Here!

                    return true
                }
            }

        showName?.onPreferenceChangeListener =
            PrefChanges
        nameValue?.onPreferenceChangeListener =
            PrefChanges
    }
}
