package com.allmycode.p03_04_04

import androidx.room.*

@Dao
interface DaoAccess {
    @Insert
    fun insertOnlySingleMovie(movies: Movie)

    @Insert
    fun insertMultipleMovies(moviesList: List<Movie>)

    @Query("SELECT * FROM Movies WHERE movieId = :movieId")
    fun fetchOneMoviesbyMovieId(movieId: Int) : Movie

    @Query("SELECT * FROM Movies")
    fun fetchAllMovies() : Array<Movie>

    @Update
    fun updateMovie(movies: Movie)

    @Delete
    fun deleteMovie(movies: Movie)
}