package com.allmycode.p03_05_02

import android.content.res.ColorStateList
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.graphics.Color.argb
import android.graphics.drawable.BitmapDrawable
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import androidx.core.content.ContextCompat
import androidx.core.content.res.ResourcesCompat
import androidx.palette.graphics.Palette
import kotlinx.android.synthetic.main.activity_main.*
import kotlinx.android.synthetic.main.activity_main.view.*

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        if (savedInstanceState != null) {
            var selectedTheme = savedInstanceState
                .getInt("SavedTheme", -1)
            when (selectedTheme) {
                R.style.AppTheme -> setTheme(R.style.AppTheme)
                R.style.AppTheme2 -> setTheme(R.style.AppTheme2)
                else -> setTheme(R.style.AppTheme)
            }
        }
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
    }


    fun onChangeStyleClick(view: View){
        var textColor = ContextCompat.getColor(
            this, R.color.colorWhite)
        var backColor = ContextCompat.getColor(
            this, R.color.colorDarkBlue)
        ChangeStyle.setTextColor(textColor)
        ChangeStyle.setBackgroundColor(backColor)

        var myPalette = Palette.from(
            BitmapFactory.decodeResource(
                resources,
                R.drawable.pep_extracheese)).generate()
        SomeText.setTextColor(
            myPalette.getDarkVibrantColor(1))
        SomeText.setBackgroundColor(
            myPalette.getLightVibrantColor(1))
    }
}
